
import logging

from django.http import Http404
from django.views import View
from django.templatetags.static import static
from django.shortcuts import render, redirect
from django.urls import reverse_lazy

#-== @h1
# Website Views
#-== /website.views.py
#________________________________________


##########################################
#-== @class
class MainWebsiteView(View):
	#-== Displays the Cerrax.com website
	
	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Renders the template /website\/index.html .

	def get(self, request, *args, **kwargs):
		context = {
			'software_cards': [
				{
					'title': 'Phylo Card Generator',
					'image': 'phylo2.png',
					'text': 'In collaboration with ThinkColorful.org, this webapp allows you to create your very own deck for the educational nature card game Phylo. Featured in a talk at <a style="text-decoration: underline;cursor: pointer;" href="https://media.libreplanet.org/u/libreplanet/m/gamifying-education-the-libre-way/" target="_blank">LibrePlanet 2021</a> as well as the <a style="text-decoration: underline;cursor: pointer;" href="https://thinkcolorful.org/?p=1132" target="_blank">Hackers & Designers Summer Academy 2021</a>.',
					'try_link': 'https://thinkcolorful.org/docgenphylo/phylo_main.html',
					'source_link': 'https://gitlab.com/charles.w.koch/docgenphylo',
					'learn_link': 'https://thinkcolorful.org/?p=1048',
					'download': False,
				},
				{
					'title': 'Corndog & Ketchup',
					'image': 'candk.png',
					'text': 'A collection of Python modules for code documentation with wiki-like markup. All of the doumentation on <em>Cerrax.com</em> is generated by the Ketchup markup module.',
					'try_link': 'https://pypi.org/project/candk/',
					'source_link': 'https://gitlab.com/charles.w.koch/corndog-ketchup',
					'learn_link': 'docs/candk',
					'download': False,
				},
				{
					'title': 'Cerrax Display Library',
					'image': 'cxdl-screen.png',
					'text': 'A Javascript/CSS library for quickly and easily creating reponsive and dynamic website layouts. In fact, all of <em>Cerrax.com</em> is done with the CxDL!',
					'try_link': 'https://gitlab.com/charles.w.koch/cxdl',
					'source_link': 'https://gitlab.com/charles.w.koch/cxdl',
					'learn_link': 'docs/cxdl',
					'download': True,
				},
				{
					'title': 'Cerrax Cloud',
					'image': 'cx-cloud.jpeg',
					'text': 'A collection of useful apps for organization, such as a list app and personal planner.',
					'try_link': reverse_lazy('core:login'),
					'source_link': 'https://gitlab.com/charles.w.koch/cerrax-cloud',
					'learn_link': 'docs/cx-cloud',
					'download': False,
				},
				{
					'title': 'TextTool 2',
					'image': 'text2.png',
					'text': 'An HTML5/jQuery-powered text file filtering app. TextTool 2 uses regular expressions that can be color coded to make it quick and easy to scan a list of results and find exactly what you need.',
					'try_link': reverse_lazy('website:texttool2'),
					'learn_link': 'docs/texttool',
					'download': False,
				},
				{
					'title': 'Gizeel Temp. Gauge',
					'image': 'gizeel.png',
					'text': 'A fun little joke thermometer which measures temperature in "degrees Gizeel".',
					'try_link': reverse_lazy('website:gizeel'),
					'learn_link': 'docs/gizeel',
					'download': False,
				},
				{
					'title': 'Project CX',
					'image': 'screen2.png',
					'text': 'A lightweight project management and issue tracking web app.',
					'try_link': static('website/files/ProjectCX-1.0.2.zip'),
					'try_text': 'DOWNLOAD (v1.0.2)',
					'learn_link': 'docs/projectcx',
					'download': True,
				},
				{
					'title': 'Star Faux',
					'image': 'starfaux.png',
					'text': 'A tech demo homage to the 1993 gaming classic, StarFox. This simple game engine was created from scratch in C++ using OpenGL and SOIL frameworks for macOS.',
					'try_link': static('website/files/StarFauxApp.zip'),
					'try_text': 'DOWNLOAD (macOS)',
					'learn_link': 'docs/starfaux',
					'download': True,
				},
			],
			'music_cards': [
				{
					'title': 'Bandcamp',
					'image': 'bandcamp.png',
					'text': "Miscellaneous works (both original and remixes) that don't really fit under any specific category.",
					'link': 'https://cerrax.bandcamp.com/',
				},
				{
					'title': 'Overclocked ReMix',
					'image': 'ocr.jpg',
					'text': 'OCR is a community dedicated to the appreciation of video game music and features a tightly curated catalogue of high-quality remixes from the entire span of video game history.',
					'link': 'http://ocremix.org/artist/4761/cerrax/remixes',
				},
				{
					'title': 'Remix ThaSauce',
					'image': 'remixthasauce.jpg',
					'text': 'ThaSauce provides a portal for news about video game music and their Remix site features remixes from a wide gamut of styles and regions.',
					'link': 'http://remix.thasauce.net/mixer/cerrax/',
				},
				{
					'title': 'The Missingno Tracks',
					'image': 'pokemon.png',
					'text': 'A remix album from Overclocked ReMix features tracks from 18 artists and a website that I designed as well!',
					'link': 'http://missingno.ocremix.org/index.html',
				},
				{
					'title': 'Maverick Rising',
					'image': 'megamanx.png',
					'text': "A 5-disc remix album feauring remixes of tunes from Capcom's popular Mega Man X series of video games.",
					'link': 'http://maverick.ocremix.org/index.php',
				},
			],
			'video_cards': [
				{
					'title': 'YouTube',
					'image': 'youtube.jpg',
					'text': 'Various videos including video game trailers, music videos, and other video editing projects.',
					'link': 'https://www.youtube.com/user/cerrax/videos',
				},
				{
					'title': 'Filmaka.com',
					'image': 'filmaka.png',
					'text': 'Monthly short film contest in which our films (<em>Crawlspace</em> and <em>InstruMental</em>) were $1500 finalists!',
					'link': 'https://www.filmaka.com/films.php?page=all&contest=10&film_id=973',
				},
			],
		}
		return render(request, 'website/index.html', context)


##########################################
#-== @class
class DocsView(View):
	#-== Displays documentation pages that are not part of the website.

	PAGES = [
		'cxdl',
		'candk',
		'gizeel',
		'projectcx',
		'starfaux',
		'cx-cloud',
		'texttool',
	]

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Renders a page referenced in the method

	def get(self, request, page, *args, **kwargs):
		if page not in self.PAGES:
			raise Http404('Page not found')

		page_name = 'website/pages/' + page + '.html'
		return render(request, page_name, {})


##########################################
#-== @class
class TextTool2(View):
	#-== Displays the page for TextTool2

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Renders the page for TextTool2

	def get(self, request, *args, **kwargs):
		return render(request, 'website/TextTool2.html', {})


##########################################
#-== @class
class Gizeel(View):
	#-== Displays the page for the Gizeel Temperature Gauge

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Renders the page for Gizeel Temperature Gauge

	def get(self, request, *args, **kwargs):
		return render(request, 'website/gizeel-app.html', {})